﻿// AlteryxAddIn.cpp : Defines the exported functions for the DLL application.
#include "stdafx.h"
#include "DemoCppFunction.h"
#include "AlteryxAbacusUtils.h"
#include <string>

//// this sample takes a variable number of inputs and returns the first non-null
extern "C" long _declspec(dllexport) _stdcall Coalesce(int nNumArgs, FormulaAddInData *pArgs, FormulaAddInData *pReturnValue)
{
	if (nNumArgs < 1) {
		pReturnValue->nVarType = 1;
		return AlteryxAbacusUtils::ReturnError(L"Need an argument!", pReturnValue, nNumArgs, pArgs);
	}

	int varType = pArgs[0].nVarType;
	pReturnValue->nVarType = varType;

	pReturnValue->isNull = 1;

	for (int x = 0; x < nNumArgs; x++)
	{
		if (pArgs[x].nVarType != varType) {
			return AlteryxAbacusUtils::ReturnError(L"Mismatched argument types, all must be same general type as first parameter.", pReturnValue, nNumArgs, pArgs);
		}

		if (!pArgs[x].isNull)
		{
			AlteryxAbacusUtils::CopyValue(&pArgs[x], pReturnValue);
			break;
		}
	}

	return AlteryxAbacusUtils::ReturnSuccess(nNumArgs, pArgs);
}
